# coding: utf-8

"""
    Isilon SDK

    Isilon SDK - Language bindings for the OneFS API  # noqa: E501

    OpenAPI spec version: 2
    Contact: sdk@isilon.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from isi_sdk_7_2.models.cloud_account import CloudAccount  # noqa: F401,E501


class CloudAccountExtended(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'account_username': 'str',
        'enabled': 'bool',
        'key': 'str',
        'name': 'str',
        'uri': 'str',
        'bucket': 'str',
        'id': 'str',
        'metadata_bucket': 'str',
        'pool': 'str',
        'type': 'str',
        'validity': 'str'
    }

    attribute_map = {
        'account_username': 'account_username',
        'enabled': 'enabled',
        'key': 'key',
        'name': 'name',
        'uri': 'uri',
        'bucket': 'bucket',
        'id': 'id',
        'metadata_bucket': 'metadata_bucket',
        'pool': 'pool',
        'type': 'type',
        'validity': 'validity'
    }

    def __init__(self, account_username=None, enabled=None, key=None, name=None, uri=None, bucket=None, id=None, metadata_bucket=None, pool=None, type=None, validity=None):  # noqa: E501
        """CloudAccountExtended - a model defined in Swagger"""  # noqa: E501

        self._account_username = None
        self._enabled = None
        self._key = None
        self._name = None
        self._uri = None
        self._bucket = None
        self._id = None
        self._metadata_bucket = None
        self._pool = None
        self._type = None
        self._validity = None
        self.discriminator = None

        if account_username is not None:
            self.account_username = account_username
        if enabled is not None:
            self.enabled = enabled
        if key is not None:
            self.key = key
        if name is not None:
            self.name = name
        if uri is not None:
            self.uri = uri
        if bucket is not None:
            self.bucket = bucket
        if id is not None:
            self.id = id
        if metadata_bucket is not None:
            self.metadata_bucket = metadata_bucket
        if pool is not None:
            self.pool = pool
        if type is not None:
            self.type = type
        if validity is not None:
            self.validity = validity

    @property
    def account_username(self):
        """Gets the account_username of this CloudAccountExtended.  # noqa: E501

        The username required to authenticate against the cloud service  # noqa: E501

        :return: The account_username of this CloudAccountExtended.  # noqa: E501
        :rtype: str
        """
        return self._account_username

    @account_username.setter
    def account_username(self, account_username):
        """Sets the account_username of this CloudAccountExtended.

        The username required to authenticate against the cloud service  # noqa: E501

        :param account_username: The account_username of this CloudAccountExtended.  # noqa: E501
        :type: str
        """

        self._account_username = account_username

    @property
    def enabled(self):
        """Gets the enabled of this CloudAccountExtended.  # noqa: E501

        Whether or not this account should be used for cloud storage  # noqa: E501

        :return: The enabled of this CloudAccountExtended.  # noqa: E501
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this CloudAccountExtended.

        Whether or not this account should be used for cloud storage  # noqa: E501

        :param enabled: The enabled of this CloudAccountExtended.  # noqa: E501
        :type: bool
        """

        self._enabled = enabled

    @property
    def key(self):
        """Gets the key of this CloudAccountExtended.  # noqa: E501

        A valid authentication key for connecting to the cloud  # noqa: E501

        :return: The key of this CloudAccountExtended.  # noqa: E501
        :rtype: str
        """
        return self._key

    @key.setter
    def key(self, key):
        """Sets the key of this CloudAccountExtended.

        A valid authentication key for connecting to the cloud  # noqa: E501

        :param key: The key of this CloudAccountExtended.  # noqa: E501
        :type: str
        """

        self._key = key

    @property
    def name(self):
        """Gets the name of this CloudAccountExtended.  # noqa: E501

        A unique name for this account  # noqa: E501

        :return: The name of this CloudAccountExtended.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CloudAccountExtended.

        A unique name for this account  # noqa: E501

        :param name: The name of this CloudAccountExtended.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def uri(self):
        """Gets the uri of this CloudAccountExtended.  # noqa: E501

        A valid URI pointing to the location of the cloud storage  # noqa: E501

        :return: The uri of this CloudAccountExtended.  # noqa: E501
        :rtype: str
        """
        return self._uri

    @uri.setter
    def uri(self, uri):
        """Sets the uri of this CloudAccountExtended.

        A valid URI pointing to the location of the cloud storage  # noqa: E501

        :param uri: The uri of this CloudAccountExtended.  # noqa: E501
        :type: str
        """

        self._uri = uri

    @property
    def bucket(self):
        """Gets the bucket of this CloudAccountExtended.  # noqa: E501

        The machine generated name of the account bucket to store data  # noqa: E501

        :return: The bucket of this CloudAccountExtended.  # noqa: E501
        :rtype: str
        """
        return self._bucket

    @bucket.setter
    def bucket(self, bucket):
        """Sets the bucket of this CloudAccountExtended.

        The machine generated name of the account bucket to store data  # noqa: E501

        :param bucket: The bucket of this CloudAccountExtended.  # noqa: E501
        :type: str
        """

        self._bucket = bucket

    @property
    def id(self):
        """Gets the id of this CloudAccountExtended.  # noqa: E501

        A globally unique name for this account  # noqa: E501

        :return: The id of this CloudAccountExtended.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CloudAccountExtended.

        A globally unique name for this account  # noqa: E501

        :param id: The id of this CloudAccountExtended.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def metadata_bucket(self):
        """Gets the metadata_bucket of this CloudAccountExtended.  # noqa: E501

        The machine generated name of the account bucket to store metadata  # noqa: E501

        :return: The metadata_bucket of this CloudAccountExtended.  # noqa: E501
        :rtype: str
        """
        return self._metadata_bucket

    @metadata_bucket.setter
    def metadata_bucket(self, metadata_bucket):
        """Sets the metadata_bucket of this CloudAccountExtended.

        The machine generated name of the account bucket to store metadata  # noqa: E501

        :param metadata_bucket: The metadata_bucket of this CloudAccountExtended.  # noqa: E501
        :type: str
        """

        self._metadata_bucket = metadata_bucket

    @property
    def pool(self):
        """Gets the pool of this CloudAccountExtended.  # noqa: E501

        Name of the pool referencing this account.  Empty if none.  # noqa: E501

        :return: The pool of this CloudAccountExtended.  # noqa: E501
        :rtype: str
        """
        return self._pool

    @pool.setter
    def pool(self, pool):
        """Sets the pool of this CloudAccountExtended.

        Name of the pool referencing this account.  Empty if none.  # noqa: E501

        :param pool: The pool of this CloudAccountExtended.  # noqa: E501
        :type: str
        """

        self._pool = pool

    @property
    def type(self):
        """Gets the type of this CloudAccountExtended.  # noqa: E501

        The type of cloud protocol required (e.g., 'ran', 'azure')  # noqa: E501

        :return: The type of this CloudAccountExtended.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this CloudAccountExtended.

        The type of cloud protocol required (e.g., 'ran', 'azure')  # noqa: E501

        :param type: The type of this CloudAccountExtended.  # noqa: E501
        :type: str
        """
        allowed_values = ["ran", "azure"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def validity(self):
        """Gets the validity of this CloudAccountExtended.  # noqa: E501

        Either 'OK' or a message indicating problems with the account (Note* only shown when 'validate=1' argument is appended to URI)  # noqa: E501

        :return: The validity of this CloudAccountExtended.  # noqa: E501
        :rtype: str
        """
        return self._validity

    @validity.setter
    def validity(self, validity):
        """Sets the validity of this CloudAccountExtended.

        Either 'OK' or a message indicating problems with the account (Note* only shown when 'validate=1' argument is appended to URI)  # noqa: E501

        :param validity: The validity of this CloudAccountExtended.  # noqa: E501
        :type: str
        """

        self._validity = validity

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CloudAccountExtended):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
